from Geometry3D import *
import copy
#available operators in Geometry3D are:
# intersection
# in - it works for lesser dimension vs bigger dimension
# ==
def dim(x):
    if isinstance(x,ConvexPolyhedron):
        return 3
    if isinstance(x,ConvexPolygon):
        return 2
    if isinstance(x,Segment):
        return 1
    if isinstance(x,Point):
        return 0
    if x is None:
        return -1
def C(x,y):
    return intersection(x,y) is not None
def DC(x,y):
    return not C(x,y)
def P(x,y):
    if dim(x)>dim(y):
        return False
    elif dim(x)==3 and dim(y)==3:
        inter=intersection(x,y)
        return x == inter
    elif dim(x)==2 and dim(y)==2:
        inter=intersection(x,y)
        return x == inter
    elif dim(x) == 0 and dim(y) == 0:
        inter = intersection(x, y)
        return x == inter
    else:
        return x in y
def EQ(x,y):
    if dim(x)==dim(y):
        return x==y
    else:
        return False
def PP(x,y):
    return P(x,y) and not EQ(x,y)
def PI(x,y):
    return P(y,x)
def PPI(x,y):
    return PP(y,x)
def boundary(y): #returns a list of objects
    if isinstance(y,ConvexPolyhedron): #returns a list of polygons
        return y.convex_polygons
    if isinstance(y,ConvexPolygon): #returns a list of segments
        return y.segments()
    if isinstance(y,Segment): #returns a list of 2 points
        return [y.start_point,y.end_point]
    if isinstance(y,Point):
        return None
def NTPP(x,y):
    result=PP(x,y)
    if result:
        for y1 in boundary(y):
            if not DC(x,y1):
                result=False
    return result
def TPP(x,y):
    return PP(x,y) and not NTPP(x,y)
def NTPPI(x,y):
    return NTPP(y,x)
def TPPI(x,y):
    return TPP(y,x)
def in_boundary(x,y): #checks if x is contained in boundary of y
    #for convex objects, it suffices that x is contained in just one part of the boundary
    result=False
    for y1 in boundary(y):
        if P(x,y1):
            result=True
    return result
def EC(x,y):
    result = C(x,y) and not P(x,y) and not PI(x,y)
    if result:
        #EC is evaluated with in_boundary
        inters = intersection(x, y)
        result = in_boundary(inters,x) or in_boundary(inters,y)
    return result

def CR(x,y):
    result = C(x, y) and not P(x, y) and not PI(x, y) and not EC(x,y)
    if result:
        inters = intersection(x, y)
        result = NTPP(inters,x) or NTPP(inters,y)
    return result
def O(x,y):
    return C(x,y) and not EC(x,y) and not CR(x,y)
def PO(x,y):
    return O(x,y) and not P(x,y) and not PI(x,y)

key_list=['DC','EC','NTPP','TPP','CR','PO','NTPPI','TPPI','EQ']
relset = [DC, EC, NTPP, TPP, CR, PO, NTPPI, TPPI, EQ]

def RCC9(x,y):
    result=[]
    for r in relset:
        if r(x,y):
            result.append(key_list[relset.index(r)])
    return result

def translated(p,dx,dy,dz):
    p2 = copy.deepcopy(p).move(Vector(dx, dy, dz))
    return p2
