from osgeo import ogr
from visuallayer import *
import matplotlib.pyplot as plt
import random

U={'DC', 'EC', 'PO', 'TPP', 'NTPP', 'TPPI', 'NTPPI', 'EQ', 'CR'}
T = {}

#added here additional cases for line-line, but leaved the impossible cases for lines
#adding cases involving both simple lines and regions
T['DC'] = {'DC': U,
           'EC': {'DC', 'EC', 'PO', 'TPP', 'NTPP', 'CR'},
           'PO': {'DC', 'EC', 'PO', 'TPP', 'NTPP', 'CR'},
           'TPP': {'DC', 'EC', 'PO', 'TPP', 'NTPP', 'CR'},
           'NTPP': {'DC', 'EC', 'PO', 'TPP', 'NTPP', 'CR'},
           'TPPI': {'DC'},
           'NTPPI': {'DC'},
           'EQ': {'DC'},
           'CR': {'DC', 'EC', 'PO', 'TPP', 'NTPP', 'CR'}}
T['EC'] = {'DC': {'DC', 'EC', 'PO', 'TPPI', 'NTPPI', 'CR'},
           'EC': U,
           'PO': {'DC', 'EC', 'PO', 'TPP', 'TPPI', 'NTPP', 'CR'},
           'TPP': {'EC', 'PO', 'TPP', 'NTPP', 'CR'},
           'NTPP': {'EC', 'PO', 'TPP', 'NTPP', 'CR'},
           'TPPI': {'DC', 'EC', 'PO', 'TPPI', 'NTPPI', 'CR'},
           'NTPPI': {'DC', 'EC', 'TPPI'},
           'EQ': {'EC'},
           'CR': {'DC', 'EC', 'PO', 'TPP', 'TPPI', 'NTPP', 'CR'}}
T['PO'] = {'DC': {'DC', 'EC', 'PO', 'TPPI', 'NTPPI', 'CR'},
           'EC': {'DC', 'EC', 'PO', 'TPP', 'TPPI', 'NTPPI', 'CR'},
           'PO': U,
           'TPP': {'EC', 'PO', 'TPP', 'NTPP', 'CR'},
           'NTPP': {'PO', 'TPP', 'NTPP', 'CR'},
           'TPPI': {'DC', 'EC', 'PO', 'TPPI', 'NTPPI', 'CR'},
           'NTPPI': {'DC', 'EC', 'PO', 'TPPI', 'NTPPI', 'CR'},
           'EQ': {'PO'},
           'CR': {'DC', 'EC', 'PO', 'TPP', 'NTPP', 'TPPI', 'NTPPI', 'CR'}}
T['TPP'] = {'DC': {'DC'},
           'EC': {'DC', 'EC', 'PO', 'TPP', 'NTPP', 'CR'},
           'PO': {'DC', 'EC', 'PO', 'TPP', 'NTPP', 'CR'},
           'TPP': {'TPP', 'NTPP'},
           'NTPP': {'NTPP'},
           'TPPI': {'DC', 'EC', 'PO', 'TPP', 'TPPI', 'NTPP', 'NTPPI', 'EQ', 'CR'},
           'NTPPI': {'DC', 'EC', 'PO', 'TPPI', 'NTPPI', 'CR'},
           'EQ': {'TPP'},
           'CR': {'DC', 'EC', 'PO', 'NTPP', 'CR'}}
T['NTPP'] = {'DC': {'DC'},
           'EC': {'DC', 'EC', 'TPP'},
           'PO': {'DC', 'EC', 'PO', 'TPP', 'NTPP', 'CR'},
           'TPP': {'TPP', 'NTPP'},
           'NTPP': {'NTPP'},
           'TPPI': {'DC', 'EC', 'PO', 'TPP', 'NTPP', 'CR'},
           'NTPPI': U,
           'EQ': {'NTPP'},
           'CR': {'DC', 'EC', 'PO', 'TPP', 'NTPP', 'CR'}}
T['TPPI'] = {'DC': {'DC', 'EC', 'PO', 'TPPI', 'NTPPI', 'CR'},
           'EC': {'EC', 'PO', 'TPPI', 'NTPPI', 'CR'},
           'PO': {'EC', 'PO', 'TPPI', 'NTPPI', 'CR'},
           'TPP': {'EC', 'PO', 'TPP', 'TPPI', 'EQ'},
           'NTPP': {'EC', 'PO', 'TPP', 'NTPP', 'TPPI', 'CR'},
           'TPPI': {'TPPI', 'NTPPI'},
           'NTPPI': {'TPPI', 'NTPPI'},
           'EQ': {'TPPI'},
           'CR': {'EC', 'PO', 'TPPI', 'NTPPI', 'CR'}}
T['NTPPI'] = {'DC': {'DC', 'EC', 'PO', 'TPPI', 'NTPPI', 'CR'},
           'EC': {'EC', 'PO', 'TPPI', 'NTPPI', 'CR'},
           'PO': {'PO', 'TPPI', 'NTPPI', 'CR'},
           'TPP': {'EC', 'PO', 'TPP', 'TPPI', 'NTPPI', 'CR'},
           'NTPP': {'PO', 'TPP', 'NTPP', 'TPPI', 'NTPPI', 'EQ', 'CR'},
           'TPPI': {'NTPPI'},
           'NTPPI': {'NTPPI'},
           'EQ': {'NTPPI'},
           'CR': {'PO', 'TPPI', 'NTPPI', 'CR'}}
T['EQ'] = {'DC': {'DC'},
           'EC': {'EC'},
           'PO': {'PO'},
           'TPP': {'TPP'},
           'NTPP': {'NTPP'},
           'TPPI': {'TPPI'},
           'NTPPI': {'NTPPI'},
           'EQ': {'EQ'},
           'CR': {'CR'}}
T['CR'] = {'DC': {'DC', 'EC', 'PO', 'TPPI', 'NTPPI', 'CR'},
           'EC': {'DC', 'EC', 'PO', 'TPP', 'TPPI', 'NTPPI', 'CR'},
           'PO': {'DC', 'EC', 'PO', 'TPP', 'NTPP', 'TPPI', 'NTPPI', 'CR'},
           'TPP': {'EC', 'PO', 'TPP', 'NTPP', 'CR'},
           'NTPP': {'PO', 'TPP', 'NTPP', 'CR'},
           'TPPI': {'DC', 'EC', 'PO', 'NTPPI', 'CR'},
           'NTPPI': {'DC', 'EC', 'PO', 'TPPI', 'NTPPI', 'CR'},
           'EQ': {'CR'},
           'CR': U}


def compare (comp,T):
    conf=[]
    for i in key_list:
        for j in key_list:
            if comp[i][j]==T[i][j]:
                pass
            else:
                print('row:',i)
                print('col:',j)
                print('comp=',comp[i][j])
                print('T=',T[i][j])
                print('miss: ', T[i][j].difference(comp[i][j]),'\n', 'found:',comp[i][j].difference(T[i][j]))
                print()
                found=comp[i][j].difference(T[i][j])
                for r in found:
                    conf.append([i,j,r])
    return conf

def create_twosquares(tx=0,ty=0,zx=1,zy=1): #tx ty translate, zx zy zoom
    ring5 = ogr.Geometry(ogr.wkbLinearRing) #outer ring
    ring5.AddPoint(0*zx+tx, 0*zy+ty)
    ring5.AddPoint(3*zx+tx, 0*zy+ty)
    ring5.AddPoint(3*zx+tx, 3*zy+ty)
    ring5.AddPoint(0*zx+tx, 3*zy+ty)
    ring5.AddPoint(0*zx+tx, 0*zy+ty)

    outer = ogr.Geometry(ogr.wkbLinearRing) #disconnected component ring
    outer.AddPoint(4*zx+tx, 1*zy+ty)
    outer.AddPoint(5*zx+tx, 1*zy+ty)
    outer.AddPoint(5*zx+tx, 2*zy+ty)
    outer.AddPoint(4*zx+tx, 2*zy+ty)
    outer.AddPoint(4*zx+tx, 1*zy+ty)

    poly = ogr.Geometry(ogr.wkbPolygon)
    poly.AddGeometry(ring5)
    comp = ogr.Geometry(ogr.wkbPolygon) #disconnected component
    comp.AddGeometry(outer)

    mpoly = ogr.Geometry(ogr.wkbMultiPolygon)
    mpoly.AddGeometry(poly)
    mpoly.AddGeometry(comp)
    #print (mpoly.ExportToWkt())
    return mpoly

def create_twosquaresinv(tx=0,ty=0,zx=1,zy=1): #tx ty translate, zx zy zoom
    ring5 = ogr.Geometry(ogr.wkbLinearRing) #outer ring
    ring5.AddPoint(0*zx+tx, 0*zy+ty)
    ring5.AddPoint(3*zx+tx, 0*zy+ty)
    ring5.AddPoint(3*zx+tx, 3*zy+ty)
    ring5.AddPoint(0*zx+tx, 3*zy+ty)
    ring5.AddPoint(0*zx+tx, 0*zy+ty)

    outer = ogr.Geometry(ogr.wkbLinearRing) #disconnected component ring
    outer.AddPoint(-3*zx+tx, 1*zy+ty)
    outer.AddPoint(-2*zx+tx, 1*zy+ty)
    outer.AddPoint(-2*zx+tx, 2*zy+ty)
    outer.AddPoint(-3*zx+tx, 2*zy+ty)
    outer.AddPoint(-3*zx+tx, 1*zy+ty)

    poly = ogr.Geometry(ogr.wkbPolygon)
    poly.AddGeometry(ring5)
    comp = ogr.Geometry(ogr.wkbPolygon) #disconnected component
    comp.AddGeometry(outer)

    mpoly = ogr.Geometry(ogr.wkbMultiPolygon)
    mpoly.AddGeometry(poly)
    mpoly.AddGeometry(comp)
    #print (mpoly.ExportToWkt())
    return mpoly

def twosquares_random(list_mpoly, n,traslx,trasly,maxzoom,minzoom):
    for i in range(int(n/2)):
        tx=random.randint(-traslx,traslx)
        ty=random.randint(-trasly,trasly)
        zx=minzoom+random.randint(1,maxzoom)
        zy=minzoom+random.randint(1,maxzoom)
        mpoly=create_twosquares(tx,ty,zx,zy)
        list_mpoly.append(mpoly)
    for i in range(int(n/2)):
        tx=random.randint(-traslx,traslx)
        ty=random.randint(-trasly,trasly)
        zx=minzoom+random.randint(1,maxzoom)
        zy=minzoom+random.randint(1,maxzoom)
        mpoly=create_twosquaresinv(tx,ty,zx,zy)
        list_mpoly.append(mpoly)
    return list_mpoly

def create_mpoly(tx=0,ty=0,zx=1,zy=1): #tx ty translate, zx zy zoom
    ring5 = ogr.Geometry(ogr.wkbLinearRing) #outer ring
    ring5.AddPoint(0*zx+tx, 0*zy+ty)
    ring5.AddPoint(5*zx+tx, 0*zy+ty)
    ring5.AddPoint(5*zx+tx, 5*zy+ty)
    ring5.AddPoint(0*zx+tx, 4*zy+ty)
    ring5.AddPoint(0*zx+tx, 0*zy+ty)

    hole0 = ogr.Geometry(ogr.wkbLinearRing) #hole
    hole0.AddPoint(1*zx+tx, 1*zy+ty)
    hole0.AddPoint(3*zx+tx, 1*zy+ty)
    hole0.AddPoint(3*zx+tx, 3*zy+ty)
    hole0.AddPoint(1*zx+tx, 3*zy+ty)
    hole0.AddPoint(1*zx+tx, 1*zy+ty)

    outer = ogr.Geometry(ogr.wkbLinearRing) #disconnected component ring
    outer.AddPoint(0*zx+tx, -1*zy+ty)
    outer.AddPoint(0*zx+tx, -2*zy+ty)
    outer.AddPoint(2*zx+tx, -2*zy+ty)
    outer.AddPoint(1*zx+tx, -1*zy+ty)
    outer.AddPoint(0*zx+tx, -1*zy+ty)
    poly = ogr.Geometry(ogr.wkbPolygon)
    poly.AddGeometry(ring5)
    poly.AddGeometry(hole0)

    comp = ogr.Geometry(ogr.wkbPolygon) #disconnected component
    comp.AddGeometry(outer)

    mpoly = ogr.Geometry(ogr.wkbMultiPolygon)
    mpoly.AddGeometry(poly)
    mpoly.AddGeometry(comp)
    #print (mpoly.ExportToWkt())
    return mpoly
def mpoly_random(list_mpoly,n,traslx,trasly,maxzoom,minzoom):
    for i in range(n):
        tx=random.randint(-traslx,traslx)
        ty=random.randint(-trasly,trasly)
        zx=minzoom+maxzoom*random.random()
        zy=minzoom+maxzoom*random.random()
        mpoly=create_mpoly(tx,ty,zx,zy)
        list_mpoly.append(mpoly)
    return list_mpoly

def create_mline(tx=0, ty=0, zx=1, zy=1):  # tx ty translate, zx zy zoom
    line1 = ogr.Geometry(ogr.wkbLineString)  # 1 piece of line
    line1.AddPoint(-1* zx + tx, -1* zy + ty)
    line1.AddPoint(0* zx + tx, 0* zy + ty)
    line1.AddPoint(0* zx + tx, 2* zy + ty)
    line1.AddPoint(1* zx + tx, 2* zy + ty)
    line1.AddPoint(1* zx + tx, 1* zy + ty)
    line1.AddPoint(0* zx + tx, 0* zy + ty)
    line1.AddPoint(1* zx + tx, -1* zy + ty)
    line3 = ogr.Geometry(ogr.wkbLineString)  # 3 piece of line
    line3.AddPoint(2* zx + tx, 0* zy + ty)
    line3.AddPoint(3* zx + tx, 0* zy + ty)
    # Create multilinestring
    mline = ogr.Geometry(ogr.wkbMultiLineString)
    mline.AddGeometry(line1)
    mline.AddGeometry(line3)
    return mline

def mline_random(list_mline,n,traslx,trasly,maxzoom,minzoom):
    for i in range(n):
        tx=random.randint(-traslx,traslx)
        ty=random.randint(-trasly,trasly)
        zx=minzoom+maxzoom*random.random()
        zy=minzoom+maxzoom*random.random()
        mline=create_mline(tx,ty,zx,zy)
        list_mline.append(mline)
    return list_mline

def create_poly(tx=0,ty=0,zx=1,zy=1): #tx ty translate, zx zy zoom
    ring5 = ogr.Geometry(ogr.wkbLinearRing) #outer ring
    ring5.AddPoint(0*zx+tx, 0*zy+ty)
    ring5.AddPoint(5*zx+tx, 0*zy+ty)
    ring5.AddPoint(5*zx+tx, 5*zy+ty)
    ring5.AddPoint(0*zx+tx, 4*zy+ty)
    ring5.AddPoint(0*zx+tx, 0*zy+ty)
    poly = ogr.Geometry(ogr.wkbPolygon)
    poly.AddGeometry(ring5)
    return poly
def create_square(tx=0,ty=0,zx=1,zy=1): #tx ty translate, zx zy zoom
    ring5 = ogr.Geometry(ogr.wkbLinearRing) #outer ring
    ring5.AddPoint(0*zx+tx, 0*zy+ty)
    ring5.AddPoint(1*zx+tx, 0*zy+ty)
    ring5.AddPoint(1*zx+tx, 1*zy+ty)
    ring5.AddPoint(0*zx+tx, 1*zy+ty)
    ring5.AddPoint(0*zx+tx, 0*zy+ty)
    poly = ogr.Geometry(ogr.wkbPolygon)
    poly.AddGeometry(ring5)
    return poly

def simplepoly_random(list_mpoly, n,traslx,trasly,maxzoom,minzoom):
    for i in range(int(n/2)):
        tx=random.randint(-traslx,traslx)
        ty=random.randint(-trasly,trasly)
        zx=minzoom+random.randint(1,maxzoom)
        zy=minzoom+random.randint(1,maxzoom)
        mpoly=create_poly(tx,ty,zx,zy)
        list_mpoly.append(mpoly)
    for i in range(int(n/2)):
        tx=random.randint(-traslx,traslx)
        ty=random.randint(-trasly,trasly)
        zx=minzoom+random.randint(1,maxzoom)
        zy=minzoom+random.randint(1,maxzoom)
        mpoly=create_square(tx,ty,zx,zy)
        list_mpoly.append(mpoly)
    return list_mpoly

def create_line_h(tx=0, ty=0, zx=1, zy=1):  # tx ty translate, zx zy zoom
    line1 = ogr.Geometry(ogr.wkbLineString)  # 1 piece of line
    line1.AddPoint(0* zx + tx, 0* zy + ty)
    line1.AddPoint(2* zx + tx, 0* zy + ty)
    return line1
def create_line_v(tx=0, ty=0, zx=1, zy=1):  # tx ty translate, zx zy zoom
    line1 = ogr.Geometry(ogr.wkbLineString)  # 1 piece of line
    line1.AddPoint(0* zx + tx, 0* zy + ty)
    line1.AddPoint(0* zx + tx, 2* zy + ty)
    return line1
def linehv_random(list_mline,n,traslx,trasly,maxzoom,minzoom):
    for i in range(int(n/2)):
        tx=random.randint(-traslx,traslx)
        ty=random.randint(-trasly,trasly)
        zx=minzoom+random.randint(1,maxzoom)
        zy=minzoom+random.randint(1,maxzoom)
        mline=create_line_h(tx,ty,zx,zy)
        list_mline.append(mline)
    for i in range(int(n/2)):
        tx=random.randint(-traslx,traslx)
        ty=random.randint(-trasly,trasly)
        zx=minzoom+random.randint(1,maxzoom)
        zy=minzoom+random.randint(1,maxzoom)
        mline=create_line_v(tx,ty,zx,zy)
        list_mline.append(mline)
    return list_mline

def create_multiline_h(tx=0, ty=0, zx=1, zy=1):  # tx ty translate, zx zy zoom
    line1 = ogr.Geometry(ogr.wkbLineString)  # 1 piece of line
    line1.AddPoint(0* zx + tx, 0* zy + ty)
    line1.AddPoint(2* zx + tx, 0* zy + ty)
    line2 = ogr.Geometry(ogr.wkbLineString)  # 1 piece of line
    line2.AddPoint(4* zx + tx, 0* zy + ty)
    line2.AddPoint(6* zx + tx, 0* zy + ty)
    mline = ogr.Geometry(ogr.wkbMultiLineString)
    mline.AddGeometry(line1)
    mline.AddGeometry(line2)
    return mline
def create_multiline_v(tx=0, ty=0, zx=1, zy=1):  # tx ty translate, zx zy zoom
    line1 = ogr.Geometry(ogr.wkbLineString)  # 1 piece of line
    line1.AddPoint(0* zx + tx, 0* zy + ty)
    line1.AddPoint(0* zx + tx, 2* zy + ty)
    line2 = ogr.Geometry(ogr.wkbLineString)  # 1 piece of line
    line2.AddPoint(0* zx + tx, 4* zy + ty)
    line2.AddPoint(0* zx + tx, 6* zy + ty)
    mline = ogr.Geometry(ogr.wkbMultiLineString)
    mline.AddGeometry(line1)
    mline.AddGeometry(line2)
    return mline
def multilinehv_random(list_mline,n,traslx,trasly,maxzoom,minzoom):
    for i in range(int(n/2)):
        tx=random.randint(-traslx,traslx)
        ty=random.randint(-trasly,trasly)
        zx=minzoom+random.randint(1,maxzoom)
        zy=minzoom+random.randint(1,maxzoom)
        mline=create_multiline_h(tx,ty,zx,zy)
        list_mline.append(mline)
    for i in range(int(n/2)):
        tx=random.randint(-traslx,traslx)
        ty=random.randint(-trasly,trasly)
        zx=minzoom+random.randint(1,maxzoom)
        zy=minzoom+random.randint(1,maxzoom)
        mline=create_multiline_v(tx,ty,zx,zy)
        list_mline.append(mline)
    return list_mline

def create_simpleline(tx=0, ty=0, zx=1, zy=1):  # tx ty translate, zx zy zoom
    line1 = ogr.Geometry(ogr.wkbLineString)  # 1 piece of line
    line1.AddPoint(-1* zx + tx, -1* zy + ty)
    line1.AddPoint(0* zx + tx, 0* zy + ty)
    line1.AddPoint(0* zx + tx, 2* zy + ty)
    line1.AddPoint(1* zx + tx, 2* zy + ty)
    line1.AddPoint(1* zx + tx, 1* zy + ty)
    return line1
def simpleline_random(list_mline,n,traslx,trasly,maxzoom,minzoom):
    for i in range(n):
        tx=random.randint(-traslx,traslx)
        ty=random.randint(-trasly,trasly)
        zx=minzoom+maxzoom*random.random()
        zy=minzoom+maxzoom*random.random()
        mline=create_simpleline(tx,ty,zx,zy)
        list_mline.append(mline)
    return list_mline
def particular_cases(list_mpoly, n,traslx,trasly,maxzoom,minzoom):
    for i in range(n):
        tx = random.randint(-traslx, traslx)
        ty = random.randint(-trasly, trasly)
        zx = minzoom + random.randint(1, maxzoom)
        zy = minzoom + random.randint(1, maxzoom)
        mpoly=create_twosquares(tx,ty,zx,zy)
        list_mpoly.append(mpoly)
        mpoly=create_square(tx,ty,zx,zy)
        list_mpoly.append(mpoly)
        mpoly=create_poly(tx,ty,zx,zy)
        list_mpoly.append(mpoly)
        mpoly=create_twosquaresinv(tx,ty,zx,zy)
        list_mpoly.append(mpoly)
        #draw(list_mpoly)
    return list_mpoly
def particular_cases_lines(list_mpoly, n,traslx,trasly,maxzoom,minzoom):
    for i in range(n):
        tx = random.randint(-traslx, traslx)
        ty = random.randint(-trasly, trasly)
        zx = minzoom + random.randint(1, maxzoom)
        zy = minzoom + random.randint(1, maxzoom)
        line1 = ogr.Geometry(ogr.wkbLineString)  # 1 piece of line
        line1.AddPoint(0 * zx + tx, 0 * zy + ty)
        line1.AddPoint(3 * zx + tx, 0 * zy + ty)
        list_mpoly.append(line1)
        line2 = ogr.Geometry(ogr.wkbLineString)  # 1 piece of line
        line2.AddPoint(3 * zx + tx-1, 0 * zy + ty)
        line2.AddPoint(6 * zx + tx-1, 0 * zy + ty)
        list_mpoly.append(line2)
        line3 = ogr.Geometry(ogr.wkbLineString)  # 1 piece of line
        line3.AddPoint(6 * zx + tx-2, 0 * zy + ty)
        line3.AddPoint(9 * zx + tx-2, 0 * zy + ty)
        line3.AddPoint(9 * zx + tx-2, 2 * zy + ty)
        line3.AddPoint(0 * zx + tx+1, 2 * zy + ty)
        line3.AddPoint(0 * zx + tx+1, -2 * zy + ty)
        list_mpoly.append(line3)
        #draw(list_mpoly)
        #exit()
    return list_mpoly
def create_mpoint(tx=0, ty=0, zx=1, zy=1):  # tx ty translate, zx zy zoom
    mpoint= ogr.Geometry(ogr.wkbMultiPoint)
    point1 = ogr.Geometry(ogr.wkbPoint)
    point1.AddPoint(2* zx + tx,0* zy + ty)
    mpoint.AddGeometry(point1)
    point2 = ogr.Geometry(ogr.wkbPoint)
    point2.AddPoint(3* zx + tx,0* zy + ty)
    mpoint.AddGeometry(point2)
    point3 = ogr.Geometry(ogr.wkbPoint)
    point3.AddPoint(4 * zx + tx, 0 * zy + ty)
    mpoint.AddGeometry(point3)
    return mpoint

def create_point1(tx=0, ty=0, zx=1, zy=1):  # tx ty translate, zx zy zoom
    mpoint1= ogr.Geometry(ogr.wkbMultiPoint)
    #point1 = ogr.Geometry(ogr.wkbPoint)
    #point1.AddPoint(2* zx + tx,0* zy + ty)
    #mpoint1.AddGeometry(point1)
    point2 = ogr.Geometry(ogr.wkbPoint)
    point2.AddPoint(3* zx + tx,0* zy + ty)
    mpoint1.AddGeometry(point2)
    #point3 = ogr.Geometry(ogr.wkbPoint)
    #point3.AddPoint(6 * zx + tx, 2 * zy + ty)
    #mpoint1.AddGeometry(point3)
    return mpoint1
def mpoint_random(list_mpoint,n,traslx,trasly,maxzoom,minzoom):
    for i in range(int(n/2)):
        tx=random.randint(-traslx,traslx)
        ty=random.randint(-trasly,trasly)
        zx=minzoom+maxzoom*random.random()
        zy=minzoom+maxzoom*random.random()
        mpoint=create_mpoint(tx,ty,zx,zy)
        list_mpoint.append(mpoint)
        mpoint = create_point1(tx, ty, zx, zy)
        list_mpoint.append(mpoint)
    return list_mpoint

from shapely import wkt
def relate(geom1,geom2):
    st1=geom1.ExportToWkt()
    st2=geom2.ExportToWkt()
    obj1=wkt.loads(st1)
    obj2 = wkt.loads(st2)
    pattern=obj1.relate(obj2)
    return pattern


import re
def cod_RCC9(patternDE9IM):
    pattern9IM=""
    for ch in patternDE9IM:
        if ch=="F":
            pattern9IM=pattern9IM+ch
        else:
            pattern9IM=pattern9IM+'T'
    cod = []
    DC = re.compile('FF.FF...')
    EC1 = re.compile('FTT...T..')
    EC2 = re.compile('F.TT..T..')
    EC3 = re.compile('F.T.T.T..')
    NTPP = re.compile('.FF.FFT..')
    TPP1 = re.compile('.TF..F...')
    TPP2 = re.compile('..F.TF...')
    TPP3 = re.compile('TFFFTFFFT')
    CR1 = re.compile('T.TFFTT..')
    CR2 = re.compile('TFT.F.TT.')
    CR3 = re.compile('TFTFFFTFT')
    CR4 = re.compile('TTTFFFTTT')
    CR5 = re.compile('TFTTFTTFT')
    PO1 = re.compile('TTTT..T..')
    PO2 = re.compile('T.T.T.T..')
    NTPPI = re.compile('..TFF.FF.')
    TPPI1 = re.compile('...T..FF.')
    TPPI2 = re.compile('....T.FF.')
    TPPI3 = re.compile('TFFFTFFFT')
    EQ = re.compile('TFFF.FFFT')
    if re.match(DC, pattern9IM):
        cod.append('DC')
    if re.match(EC1, pattern9IM) or re.match(EC2, pattern9IM) or re.match(EC3, pattern9IM):
        cod.append('EC')
    if re.match(NTPP, pattern9IM):
        cod.append('NTPP')
    if re.match(TPP1, pattern9IM) or re.match(TPP2, pattern9IM) and not re.match(TPP3, pattern9IM):
        cod.append('TPP')
    if re.match(CR1, pattern9IM) or re.match(CR2, pattern9IM) or re.match(CR3, pattern9IM) or\
            re.match(CR4, pattern9IM) or re.match(CR5, pattern9IM):
        cod.append('CR')
    if re.match(PO1, pattern9IM) or re.match(PO2, pattern9IM):
        cod.append('PO')
    if re.match(NTPPI, pattern9IM):
        cod.append('NTPPI')
    if re.match(TPPI1, pattern9IM) or re.match(TPPI2, pattern9IM) and not re.match(TPPI3, pattern9IM):
        cod.append('TPPI')
    if re.match(EQ, pattern9IM):
        cod.append('EQ')
    if cod==[]:
        print(pattern9IM)
    return cod

def draw(list_mpoly):
    for mpoly in list_mpoly:
        color = get_random_color()
        plot_geometry(mpoly, edgecolor="grey", fillcolor=color, color=color,
                holeedgecolor='grey', holefillcolor='white', fill=True)
    plt.show()

def build_tablecod(list_feat,n):
    table=[[0]*n for i in range(n)]
    for i in range(n):
        for j in range(n):
            pattern=relate(list_feat[i],list_feat[j])
            table[i][j]=pattern

    tablecod=[[0]*n for i in range(n)]
    for i in range(n):
        for j in range(n):
            rel = cod_RCC9(table[i][j])
            if len(rel) > 1 or rel == []:
                print(i, j, rel)
                print(table[i][j])
                print(list_feat[i])
                print(list_feat[j])
                draw([list_feat[i],list_feat[j]])
                plt.show()
                exit()
            tablecod[i][j]=rel[0]
    return tablecod

def search_conf(list_feat,tablecod,conf):
    n=len(list_feat)
    r1=conf[0]
    r2=conf[1]
    r3=conf[2]
    for i in range(n):
        for j in range(n):
            if tablecod[i][j]==r1:
                i1=i
                i2=j
                for k in range(n):
                    if tablecod[i2][k]==r2:
                        i3=k
                        if tablecod[i1][i3]==r3:
                            print(i1, i2, r1)
                            print(i2, i3, r2)
                            print(i1, i3, r3)
                            print(list_feat[i1])
                            print(list_feat[i2])
                            print(list_feat[i3])
                            print()
                            draw([list_feat[i1], list_feat[i2], list_feat[i3]])
                            plt.show()
                            return



key_list = ['DC', 'EC', 'PO', 'TPP', 'NTPP', 'TPPI', 'NTPPI', 'EQ', 'CR']
comp=dict.fromkeys(key_list,{})
for key in key_list:
    comp[key]=dict.fromkeys(key_list,set())

for times in range(1):
    list_feat=linehv_random([],50,5,5,3,0)
    addlist=simpleline_random([],50,5,5,4,0.5)
    list_feat = list_feat + addlist
    addlist=particular_cases_lines([],10,5,5,3,0)
    list_feat = list_feat + addlist
    addlist=simplepoly_random([],50,3,3,2,0) #100,5,5,3,0 gives sort of equiprobable set of relations
    list_feat = list_feat + addlist
    addlist = twosquares_random([], 100, 5, 5, 3, 0)
    list_feat = list_feat + addlist
    addlist = mpoly_random([], 50, 5, 5, 4, 0.5)
    list_feat = list_feat + addlist
    addlist = particular_cases([], 10, 5, 5, 4, 0)
    list_feat = list_feat + addlist
    addlist=mline_random([],50,5,5,4,0.5)
    list_feat = list_feat + addlist
    addlist=multilinehv_random([],50,5,5,3,0)
    list_feat = list_feat + addlist
    addlist = mpoint_random([], 100, 2, 2, 2, 0.5)
    list_feat = list_feat + addlist


    draw(list_feat)
    n=len(list_feat)
    tablecod=build_tablecod(list_feat, n)

    dict = dict.fromkeys(key_list, 0)
    for i in range(n):
        for j in range(n):
            r=tablecod[i][j]
            dict[r] = dict[r] + 1
    print(dict)

    for i in range(n):
        for j in range(n):
            for k in range(n):
                r1=tablecod[i][j]
                r2=tablecod[j][k]
                r3=tablecod[i][k]
                comp[r1][r2]=comp[r1][r2].union({r3})

conf=compare(comp,T)
for c in conf:
    print(c)
    search_conf(list_feat,tablecod,c)

'''
additional cases found for a combination of simple lines and regions:

'EC', 'PO', 'TPPI'
'EC', 'TPPI', 'CR'
'EC', 'TPPI', 'NTPPI'
'EC', 'TPPI', 'TPPI'
'EC', 'TPPI', 'PO'
'EC', 'NTPPI', 'TPPI'
'EC', 'CR', 'TPPI'
'PO', 'EC', 'TPP'
'PO', 'TPP', 'EC'
'TPP', 'EC', 'CR'
'TPP', 'EC', 'NTPP'
'TPP', 'EC', 'TPP'
'TPP', 'EC', 'PO'
'TPP', 'TPPI', 'NTPPI'
'TPP', 'TPPI', 'NTPP'
'NTPP', 'EC', 'TPP'
'NTPP', 'TPP', 'TPP'
'TPPI', 'PO', 'EC'
'TPPI', 'TPP', 'EC'
'TPPI', 'NTPP', 'EC'
'TPPI', 'NTPP', 'TPPI'
'TPPI', 'NTPPI', 'TPPI'
'TPPI', 'CR', 'EC'
'NTPPI', 'TPP', 'EC'
'NTPPI', 'TPP', 'TPP'
'CR', 'EC', 'TPP'
'CR', 'TPP', 'EC'
'''