from osgeo import ogr
from visuallayer import *
import matplotlib
import matplotlib.pyplot as plt
import numpy as np

import random

def create_simplepoly(tx=0,ty=0,zx=1,zy=1): #tx ty translate, zx zy zoom
    ring5 = ogr.Geometry(ogr.wkbLinearRing) #outer ring
    ring5.AddPoint(0*zx+tx, 0*zy+ty)
    ring5.AddPoint(5*zx+tx, 0*zy+ty)
    ring5.AddPoint(5*zx+tx, 5*zy+ty)
    ring5.AddPoint(0*zx+tx, 4*zy+ty)
    ring5.AddPoint(0*zx+tx, 0*zy+ty)

    poly = ogr.Geometry(ogr.wkbPolygon)
    poly.AddGeometry(ring5)

    #print (mpoly.ExportToWkt())
    return poly

def create_simpleline(tx=0, ty=0, zx=1, zy=1):  # tx ty translate, zx zy zoom
    line1 = ogr.Geometry(ogr.wkbLineString)  # 1 piece of line
    line1.AddPoint(-1* zx + tx, -1* zy + ty)
    line1.AddPoint(0* zx + tx, 0* zy + ty)
    line1.AddPoint(0* zx + tx, 2* zy + ty)
    line1.AddPoint(1* zx + tx, 2* zy + ty)
    line1.AddPoint(1* zx + tx, 0* zy + ty)
    line1.AddPoint(3 * zx + tx, 0 * zy + ty)
    line1.AddPoint(3* zx + tx, 2* zy + ty)
    return line1

def create_mpoint(tx=0, ty=0, zx=1, zy=1):  # tx ty translate, zx zy zoom
    point1= ogr.Geometry(ogr.wkbPoint)
    point1.AddPoint(2* zx + tx,0* zy + ty)
    point2= ogr.Geometry(ogr.wkbPoint)
    point2.AddPoint(0* zx + tx,3* zy + ty)
    mpoint = ogr.Geometry(ogr.wkbMultiPoint) #multipoint
    mpoint.AddGeometry(point1)
    mpoint.AddGeometry(point2)
    return mpoint

def poly_random(n,traslx,trasly,maxzoom,minzoom):
    list_poly=[]
    for i in range(n):
        tx=random.randint(-traslx,traslx)
        ty=random.randint(-trasly,trasly)
        zx=minzoom+maxzoom*random.random()
        zy=minzoom+maxzoom*random.random()
        poly=create_simplepoly(tx,ty,zx,zy)
        list_poly.append(poly)
    return list_poly

def line_random(n,traslx,trasly,maxzoom,minzoom):
    list_line=[]
    for i in range(n):
        tx=random.randint(-traslx,traslx)
        ty=random.randint(-trasly,trasly)
        zx=minzoom+maxzoom*random.random()
        zy=minzoom+maxzoom*random.random()
        line=create_simpleline(tx,ty,zx,zy)
        list_line.append(line)
    return list_line
def create_line_h(tx=0, ty=0, zx=1, zy=1):  # tx ty translate, zx zy zoom
    line1 = ogr.Geometry(ogr.wkbLineString)  # 1 piece of line
    line1.AddPoint(0* zx + tx, 0* zy + ty)
    line1.AddPoint(2* zx + tx, 0* zy + ty)
    return line1
def create_line_v(tx=0, ty=0, zx=1, zy=1):  # tx ty translate, zx zy zoom
    line1 = ogr.Geometry(ogr.wkbLineString)  # 1 piece of line
    line1.AddPoint(0* zx + tx, 0* zy + ty)
    line1.AddPoint(0* zx + tx, 2* zy + ty)
    return line1
def linehv_random(list_mline,n,traslx,trasly,maxzoom,minzoom):
    for i in range(int(n/2)):
        tx=random.randint(-traslx,traslx)
        ty=random.randint(-trasly,trasly)
        zx=minzoom+random.randint(1,maxzoom)
        zy=minzoom+random.randint(1,maxzoom)
        mline=create_line_h(tx,ty,zx,zy)
        list_mline.append(mline)
    for i in range(int(n/2)):
        tx=random.randint(-traslx,traslx)
        ty=random.randint(-trasly,trasly)
        zx=minzoom+random.randint(1,maxzoom)
        zy=minzoom+random.randint(1,maxzoom)
        mline=create_line_v(tx,ty,zx,zy)
        list_mline.append(mline)
    return list_mline

from shapely import wkt
def relate(geom1,geom2):
    st1=geom1.ExportToWkt()
    st2=geom2.ExportToWkt()
    obj1=wkt.loads(st1)
    obj2 = wkt.loads(st2)
    pattern=obj1.relate(obj2)
    return pattern

import re
def cod_RCC9(patternDE9IM):
    pattern9IM=""
    for ch in patternDE9IM:
        if ch=="F":
            pattern9IM=pattern9IM+ch
        else:
            pattern9IM=pattern9IM+'T'
    cod = []
    DC = re.compile('FF.FF...')
    EC1 = re.compile('FTT...T..')
    EC2 = re.compile('F.TT..T..')
    EC3 = re.compile('F.T.T.T..')
    NTPP = re.compile('.FF.FF...')
    TPP1 = re.compile('.TF..F...')
    TPP2 = re.compile('..F.TF...')
    TPP3 = re.compile('TFFFTFFFT')
    CR1 = re.compile('T.TFFTT..')
    CR2 = re.compile('TFT.F.TT.')
    PO1 = re.compile('TTTT..T..')
    PO2 = re.compile('T.T.T.T..')
    NTPPI = re.compile('...FF.FF.')
    TPPI1 = re.compile('...T..FF.')
    TPPI2 = re.compile('....T.FF.')
    TPPI3 = re.compile('TFFFTFFFT')
    EQ = re.compile('TFFFTFFFT')
    if re.match(DC, pattern9IM):
        cod.append('DC')
    if re.match(EC1, pattern9IM) or re.match(EC2, pattern9IM) or re.match(EC3, pattern9IM):
        cod.append('EC')
    if re.match(NTPP, pattern9IM):
        cod.append('NTPP')
    if re.match(TPP1, pattern9IM) or re.match(TPP2, pattern9IM) and not re.match(TPP3, pattern9IM):
        cod.append('TPP')
    if re.match(CR1, pattern9IM) or re.match(CR2, pattern9IM):
        cod.append('CR')
    if re.match(PO1, pattern9IM) or re.match(PO2, pattern9IM):
        cod.append('PO')
    if re.match(NTPPI, pattern9IM):
        cod.append('NTPPI')
    if re.match(TPPI1, pattern9IM) or re.match(TPPI2, pattern9IM) and not re.match(TPPI3, pattern9IM):
        cod.append('TPPI')
    if re.match(EQ, pattern9IM):
        cod.append('EQ')
    return cod

def draw(list_mpoly):
    for mpoly in list_mpoly:
        color = get_random_color()
        plot_geometry(mpoly, edgecolor="grey", fillcolor=color, color=color,
                holeedgecolor='grey', holefillcolor='white', fill=True)


def draw_bar():
    x = np.arange(len(key_list)+1)
    print(x)
    fig, ax = plt.subplots()

    val=list(dict.values())
    SUM=sum(val)
    val.append(SUM)
    print(val)
    rects = ax.bar(x, val, align='center', color="magenta", alpha=0.5)

    ax.set_ylabel('occurrence')
    ax.set_title('RCC*-9 relations (simple features)')
    ax.set_xticks(x)
    key_list.append('SUM')
    print(key_list)
    ax.set_xticklabels(key_list)
    #ax.legend()

    def autolabel(rects):
        """Attach a text label above each bar in *rects*, displaying its height."""
        for rect in rects:
            height = rect.get_height()
            label="{:.2%}".format(height/number)
            ax.annotate('{}'.format(label),
                        xy=(rect.get_x() + rect.get_width() / 2, height),
                        xytext=(0, 3),  # 3 points vertical offset
                        textcoords="offset points",
                        ha='center', va='bottom')

    autolabel(rects)

    fig.tight_layout()
    plt.show()

def experiment(n):
    list_pattern=[]
    for i in range(n):
        list_poly=poly_random(100,100,100,50,0.5)
        list_line=line_random(100,150,120,120,20)
        list_feat = linehv_random([], 200, 5, 5, 3, 0)
        list_line=list_line+list_feat
        draw(list_poly)
        draw(list_line)
        plt.show()
        for poly1 in list_poly:
            for poly2 in list_poly:
                pattern=relate(poly1,poly2)
                list_pattern.append(pattern)
        for line1 in list_line:
            for line2 in list_line:
                pattern=relate(line1,line2)
                list_pattern.append(pattern)
        for line in list_line:
            for poly in list_poly:
                pattern=relate(line,poly)
                list_pattern.append(pattern)
        for poly in list_poly:
            for line in list_line:
                pattern=relate(poly,line)
                list_pattern.append(pattern)
    return list_pattern

list_pattern=experiment(1)

key_list=['DC','EC','NTPP','TPP','CR','PO','NTPPI','TPPI','EQ']
dict=dict.fromkeys(key_list,0)
avg=dict.fromkeys(key_list)
number=len(list_pattern)
for i in range(number):
    rel=cod_RCC9(list_pattern[i])
    if len(rel) > 1 or rel==[]: #relation set is not pairwise disjoint or is not jointly exhaustive
        print(i, rel)
    dict[rel[0]]=dict[rel[0]]+1
print(dict)
for key in key_list:
    avg[key]=dict[key]/number
print(avg)
draw_bar()

